Index: src/hugo/Makefile.am
===================================================================
--- src/hugo/Makefile.am	(revision 844)
+++ src/hugo/Makefile.am	(revision 883)
@@ -7,5 +7,4 @@
 	dijkstra.h							\
 	dimacs.h							\
-	error.h								\
 	extended_pair.h                                                 \
 	fib_heap.h							\
Index: src/hugo/attic/debug.h
===================================================================
--- src/hugo/attic/debug.h	(revision 883)
+++ src/hugo/attic/debug.h	(revision 883)
@@ -0,0 +1,56 @@
+// -*- C++ -*- //
+
+#ifndef HUGO_DEBUG_H
+#define HUGO_DEBUG_H
+
+//! \file
+//! \brief Basic definitions for debug control.
+
+namespace hugo {
+
+  //! Debug mode for testing/debugging
+
+  //! Use this debug mode if you want exhaustive range and consistency checks.
+  //! It also produces verbose debug messages.
+  struct DebugOn {
+    //! Example: check whether the edges added to a path are adjacent
+    static const bool consistensy_check = true;
+
+    static const bool range_check = true;
+
+    //! Examples: initialize maps with some value;
+    //! after deleting an item from UnionFindEnum set its value in the
+    //! corresponding map to NULL...
+    static const bool ensure_safe_state = true;
+
+    static const int verbose = 5;
+  };
+
+  //! Debug mode for turning off debug aids.
+
+  //! This debud mode switches off all range and consistency checks,
+  //! as well as the debug messages.
+  //!
+  struct DebugOff {
+    static const bool consistensy_check = false;
+    static const bool range_check = false;
+    static const bool ensure_safe_state = false;
+    static const int verbose = 0;
+  };
+
+#ifdef DEBUG
+  //! The default debug mode.
+
+  //! The default debug mode.
+  //!
+  typedef DebugOn DefaultDebugMode;
+#else
+  //! The default debug mode. 
+
+  //! The default debug mode. 
+  //!
+  typedef DebugOff DefaultDebugMode;
+#endif
+
+}
+#endif // HUGO_DEBUG_H
Index: src/hugo/attic/error.h
===================================================================
--- src/hugo/attic/error.h	(revision 883)
+++ src/hugo/attic/error.h	(revision 883)
@@ -0,0 +1,68 @@
+// -*- C++ -*- //
+
+#ifndef HUGO_ERROR_H
+#define HUGO_ERROR_H
+
+//! \ingroup misc
+//! \file
+//! \brief Basic error handling (signaling) routines.
+
+#include <exception>
+#include <string>
+#include <sstream>
+
+
+namespace hugo {
+
+  /**
+   * \brief Generic exception class.
+   *
+   * \todo Do we need this?
+   *
+   * \todo Don't we need different kind of exceptions for different kind
+   * of errors?
+   * Shouldn't we use \<stdexcept\> instead?
+   */
+  class Exception : public std::exception {
+  protected:
+    std::ostringstream buf;
+  public:
+    Exception() {}
+    explicit Exception(const std::string &s) { buf << s; }
+    Exception(const Exception &e) : std::exception() {
+      buf << e.buf.str();
+    }
+    virtual ~Exception() throw() {}
+    
+    virtual const char* what() const throw() {
+      return buf.str().c_str();
+    }
+
+    Exception& operator<<(std::string const& s) { buf << s; return *this; }
+    Exception& operator<<(char const *s) { buf << s; return *this; }
+    Exception& operator<<(int i) { buf << i; return *this; }
+  };
+
+  /**
+   * \brief Generic error signaling function.
+   *
+   * \todo Do we really need this? Is it helpful?
+   */
+  inline void fault(const std::string &msg) {
+    throw Exception(msg);
+  }
+
+  /**
+   * \brief Macro for mark not yet implemented features.
+   *
+   * \todo Is this the right place for this? It should be used only in
+   * modules under development.
+   */
+
+# define FIXME(msg) \
+    do { throw ::hugo::Exception() << "FIXME: " msg " (in: "    \
+      __FILE__ ", " << __LINE__ << ")";                         \
+    } while(false)
+
+}
+#endif // HUGO_ERROR_H
Index: src/hugo/debug.h
===================================================================
--- src/hugo/debug.h	(revision 821)
+++ 	(revision )
@@ -1,56 +1,0 @@
-// -*- C++ -*- //
-
-#ifndef HUGO_DEBUG_H
-#define HUGO_DEBUG_H
-
-//! \file
-//! \brief Basic definitions for debug control.
-
-namespace hugo {
-
-  //! Debug mode for testing/debugging
-
-  //! Use this debug mode if you want exhaustive range and consistency checks.
-  //! It also produces verbose debug messages.
-  struct DebugOn {
-    //! Example: check whether the edges added to a path are adjacent
-    static const bool consistensy_check = true;
-
-    static const bool range_check = true;
-
-    //! Examples: initialize maps with some value;
-    //! after deleting an item from UnionFindEnum set its value in the
-    //! corresponding map to NULL...
-    static const bool ensure_safe_state = true;
-
-    static const int verbose = 5;
-  };
-
-  //! Debug mode for turning off debug aids.
-
-  //! This debud mode switches off all range and consistency checks,
-  //! as well as the debug messages.
-  //!
-  struct DebugOff {
-    static const bool consistensy_check = false;
-    static const bool range_check = false;
-    static const bool ensure_safe_state = false;
-    static const int verbose = 0;
-  };
-
-#ifdef DEBUG
-  //! The default debug mode.
-
-  //! The default debug mode.
-  //!
-  typedef DebugOn DefaultDebugMode;
-#else
-  //! The default debug mode. 
-
-  //! The default debug mode. 
-  //!
-  typedef DebugOff DefaultDebugMode;
-#endif
-
-}
-#endif // HUGO_DEBUG_H
Index: src/hugo/error.h
===================================================================
--- src/hugo/error.h	(revision 539)
+++ 	(revision )
@@ -1,68 +1,0 @@
-// -*- C++ -*- //
-
-#ifndef HUGO_ERROR_H
-#define HUGO_ERROR_H
-
-//! \ingroup misc
-//! \file
-//! \brief Basic error handling (signaling) routines.
-
-#include <exception>
-#include <string>
-#include <sstream>
-
-
-namespace hugo {
-
-  /**
-   * \brief Generic exception class.
-   *
-   * \todo Do we need this?
-   *
-   * \todo Don't we need different kind of exceptions for different kind
-   * of errors?
-   * Shouldn't we use \<stdexcept\> instead?
-   */
-  class Exception : public std::exception {
-  protected:
-    std::ostringstream buf;
-  public:
-    Exception() {}
-    explicit Exception(const std::string &s) { buf << s; }
-    Exception(const Exception &e) : std::exception() {
-      buf << e.buf.str();
-    }
-    virtual ~Exception() throw() {}
-    
-    virtual const char* what() const throw() {
-      return buf.str().c_str();
-    }
-
-    Exception& operator<<(std::string const& s) { buf << s; return *this; }
-    Exception& operator<<(char const *s) { buf << s; return *this; }
-    Exception& operator<<(int i) { buf << i; return *this; }
-  };
-
-  /**
-   * \brief Generic error signaling function.
-   *
-   * \todo Do we really need this? Is it helpful?
-   */
-  inline void fault(const std::string &msg) {
-    throw Exception(msg);
-  }
-
-  /**
-   * \brief Macro for mark not yet implemented features.
-   *
-   * \todo Is this the right place for this? It should be used only in
-   * modules under development.
-   */
-
-# define FIXME(msg) \
-    do { throw ::hugo::Exception() << "FIXME: " msg " (in: "    \
-      __FILE__ ", " << __LINE__ << ")";                         \
-    } while(false)
-
-}
-#endif // HUGO_ERROR_H